#include <ctype.h>
#include <cv/config.h>
#include <cv/string2.h>


#define Spaces		" \t"
#define isSpace(ch)	((ch) == ' ' || (ch) == '\t')
#define isEOL(ch)	((ch) == '\n' || (ch) == EOF)

#define SkipSpaces()	{ while((ch = fgetc(cfg)) == ' ' || ch == '\t'); }
#define ForLine()	for(; !isEOL(ch); ch = fgetc(cfg))
#define WhileLine(cond)	for(; !isEOL(ch) && (cond); ch = fgetc(cfg))
#define SkipLine()	ForLine();

#define retSectStart()	{ line = sline; fsetpos(cfg, &psect); }
#define setSectStart()	{ sline = line; fgetpos(cfg, &psect); }

#define getRestLine(s)	{ s.trunc(); SkipSpaces(); \
			  WhileLine(ch != NOTE) s += ch; }
