#include "libdef.inc"
#if !defined(STD_CODE) && defined(ASM86_CODE)
# include <cv/asm86.h>
#endif
#include <cv/string2.h>

/* "Check for stack overflow" off for BC++ 3.1 */
#pragma option -N-

/*----------------------------------------------------------------------*/
/*    ப ᥣ,  ᮤঠ饣    	*/
/* . 頥   ᥣ			*/

size_t SMALL_ memrcspan(CVP seq, size_t seqlen, CVP s, size_t slen){
#if defined(STD_CODE) || !defined(ASM86_CODE)

#pragma intrinsic memchr
#define sq (*(const char**)&seq)

	if(sq == NULL) seqlen = 0;
	count len = 0; sq += seqlen;
	for(; len < seqlen; len++){
		sq--; if(memchr(s, *sq, slen)) break;
	}
	return len;
#else
	_BX = _AX = seqlen;
	/* if(slen == 0) return seqlen; */
	_DX = slen; if(_DX == 0) return _AX;

	pushDS_; I cld;
	I LDS_ si, DPTR_(seq);			/* DS_:si = seq		*/
	I LES_ dx, DPTR_(s);			/* ES_:dx = s		*/
#  ifndef FARDATA
	_ES = _AX = _DS;
#  endif

	for(;;){ if(_BX == 0) break;		/* while(bx--)		*/
		_BX--; I mov al, si[bx];	/* al = seq[bx]		*/
		_DI = _DX; _CX = slen;		/* ES_:di = s		*/
		I repne scasb;
		if(isFLAG(Equal)) { _BX++; break; }
	}
	popDS_; _AX = seqlen - _BX; return _AX;
#endif
}
