#if defined(__MSDOS__) && defined(__TURBOC__)


/*  DOS- Windows ᫥ Int1A ॣ al (䫠 ᬥ ) ᥣ	*/
/*  (  䫠  뢠 ⠪    BIOS),	*/
/* - 祣  clock()  BC++ 3.1  뢠 Int21/AH=0x2A (Query	*/
/* DOS Date)  ॢ ,  ᫥騥 ᫥ 襤襣	*/
/* ६ 믮 ࠢ쭮.  ⮣, ᫨ ᫥ 䫠 ᬥ	*/
/*  㤥  襭,   ⠪  ⠭  ॢ񭭮.	*/

/*  ⪠ 蠥 ,  稪 ६  䫠 ᬥ	*/
/*  ( ⠪ ⥬ 뢠     BIOS)  १	*/
/* Int1A,  १ אַ 饭    BIOS		*/


#include <time.h>
#include <cv/dos.h>
#include <cv/types.h>


/* beginning of program execution initialized in C0.ASM */
extern ulong _StartTime;

static ulong last;
static long daysFlip;
static byte flag;


#define BIOStime()	(*((volatile ulong far*)MK_FP(0x40, 0x6C)))
#define BIOSflip()	(*((volatile byte far*)MK_FP(0x40, 0x70)))
#define setBIOSflip(v)	(BIOSflip() = v)


clock_t clock(void){
	ulong now = BIOStime();
	byte flip = BIOSflip();
	if(flip){			/* did day change just now?	*/
		/* get DOS date to force DOS to recognize date change	*/
		asm { mov ah, 0x2a; int 0x21; }

		/*   ⭮,   ᬥ 	*/
		/*  祭 ६ now=  祭 䫠	*/
		/* ᬥ  flip=					*/
		now = BIOStime();
		setBIOSflip(0);		/*!!! --- WINDOWS BUG FIX --- !!!*/
	}
	if(flag == 0) { daysFlip = -(last = _StartTime); flag = 1; }

/*    ࠢ쭮 ᫥ ६ -  ᮢ	*/
/*  ᬥ : ஢  䫠 ᬥ , ⠪  ⥪饥 ६ 	*/
/* ࠢ  ६ ᫥ ᪠. ⭮  ६	*/
/*  ࠢ  - ਬ, ᫨  맮 clock() ன	*/
/*  24- ᮢ,  ਧ ᬥ  㦥 㤥 ࠡ⠭  㣮	*/
/*  -   ⢥ 㬥				*/
	if(flip || now < last)
		daysFlip += 1573040ul;	/* number of clock ticks in day	*/
	return (last = now) + daysFlip;
}

#endif
