#ifndef _h_TIMER_
#define _h_TIMER_

#include <time.h>
#ifndef _h_TYPES_
# include <cv/types.h>
#endif


class Timer;
typedef ulong MSec;	/* ᥪ㭤 (  ᥪ㭤) */

#define clk2msec(clk)	(10000ul * (clk) / count(CLOCKS_PER_SEC * 10))


/*---------------------------------------------------------*/
#pragma warn -inl
struct Timer{
	ulong total, last, go;

	Timer()			:total(0), last(0), go(false) { init(); }
	~Timer()		{ done(); }
	void	init()		{}
	void	done()		{}
	void	restart()	{ total = 0; on(); }
	void	on()		{ last = clock(); go = true; }
	void	off()		{ if(go) { total += last = clock() - last;
						go = false; } }
	ulong	elapsed()	{ return go ? clock() - last : last; }

	/* ஭  砫 㪠 ⠪ */
	static void sync(count nx)
			{ for(clock_t st = clock() + nx; clock() < st;); }
}; /* Timer */
#pragma warn .inl

#endif /* _h_TIMER_ */
