#include <cv/config.h>


enum{	s_stmtLine = wconfig::s_stmtSpace + 1,
	m_stmtLine = Mask(s_stmtLine)
};

#define FPUT(s)		fwrite(s, 1, s.len, cfg)
#define PutSpace()	{ if(state(s_stmtSpace)) fputc(' ', cfg); }
#define PutLine()	{ fputc('\n', cfg); on(s_stmtLine); }


//=========================================================
// 쪮  ᯮ짮  . ᯮ짮 
// 䠩  㯠  䠩. 頥 䫠 ᯥ (true -
// ⨥ ᯥ譮)

// "Check for stack overflow" off for BC++ 3.1
#pragma option -N-

bool SMALL_ wconfig::_link(FILE *f){
	off(s_stmtLine); return _config::_link(f);
}

//---------------------------------------------------------
// 뢥  䠩  ᥪ樨. ᫨    
// ᪮ [],   . ⮩   뢮.
// । 뢮  뢮  ப,  ᪫祭
// ࢮ ᥪ樨, ᫨   ᥪ樨 ।   㣨
// ப ( ஫ ਧ s_stmtLine)

void SMALL_ wconfig::put(charSeq sect){
	if(cfg == NULL) return;
	parse(sect); if(sect.len == 0) return;
	if(state(s_stmtLine)) fputc('\n', cfg);
	fputc('[', cfg); FPUT(sect); fputc(']', cfg);
	PutLine();
}

//---------------------------------------------------------
// 뢥  䠩 । ࠢ. ᫨ 㬥 , 
// 뤠  ப. ᫨ ।⠢   祭, 
// comment -  ਬ砭,   ⤥  ࠢ ⠡樥 
// ᨬ ਬ砭 ( , ᫨ ᨬ ਬ砭 ࠢ
// 0).   祭 ⤥  ࠢ⢠ , ᫨ ⠭
// ਧ s_stmtSpace, ஡

void SMALL_ wconfig::put(charSeq key, charSeq val, charSeq comment){
	if(cfg == NULL) return;
	if(key.len)		{ FPUT(key); PutSpace(); }
	if(key.len || val.len)	fputc('=', cfg);
	if(val.len)		{ PutSpace(); FPUT(val); }
	if(comment.len){
		char delim = CMT;
		if(key.len || val.len){
			fputc('\t', cfg); if(NOTE) delim = NOTE;
		}
		if(comment[0] != delim) fputc(delim, cfg);
		FPUT(comment);
	}
	PutLine();
}

// Recover "Check for stack overflow" state for BC++ 3.1
#pragma option -N.

//---------------------------------------------------------
// 뢥  䠩 ப 楫  ࠡ⪨
void SMALL_ wconfig::fullput(charSeq s) { if(cfg) { FPUT(s); PutLine(); } }
